package anfangsprojekt;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.transform.Affine;
import javafx.scene.transform.Rotate;

/**
 * Canvas zur Darstellung des Rechtecks.
 * <p>
 * So ist der Zeichencode in einer eigenen Klasse - sauber getrennt.
 */
public class RechteckCanvas extends Canvas {

    /**
     * Rechteck, dass wir darstellen.
     */
    private Rechteck r;

    /**
     * Constructor für das Canvas
     *
     * @param r Rechteck
     */
    public RechteckCanvas(Rechteck r) {
        super(400, 400);
        this.r = r;


        GraphicsContext gc = getGraphicsContext2D();
        //zeichne Rechteck in der Mitte des Canvans
        gc.translate(getWidth() / 2 - r.radius, getHeight() / 2 - r.radius);
        gc.save();
        gc.fillRect(0, 0, r.radius * 2, r.radius * 2);
        gc.restore();
    }

    public void draw(double dtime) {
        GraphicsContext gc = getGraphicsContext2D();
        double rotationCenter = r.radius;
        gc.clearRect(0, 0, r.radius * 2, r.radius * 2);
        //aktualisiere rotation
        gc.transform(new Affine(new Rotate(dtime * r.dr, rotationCenter, rotationCenter)));
        gc.fillRect(0, 0, r.radius * 2, r.radius * 2);
    }
}