package anfangsprojekt;

import javafx.animation.AnimationTimer;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;


public class RechteckScene extends Scene {

    /**
     * Rechteck, dass wir zeichnen.
     */
    private Rechteck r;

    /**
     * Timer zur Animation.
     */
    private AnimationTask timer;

    /**
     * Canvas zum Zeichnen des Rechtecks.
     */
    private RechteckCanvas panel;

    public RechteckScene(BorderPane root, double width, double height) {
        super(root, width, height);

        r = new Rechteck();
        panel = new RechteckCanvas(r);

        root.setCenter(panel);

        // Timer wird erst später initialisiert.
        timer = new AnimationTask();
        timer.start();
    }


    /**
     * Das vom Timer ausgelöste Ereignis.
     * <p>
     * Diese Vorgehensweise ist tolerant, wenn der Timer nicht perfekt
     * regelmäßig ausgelöst wird.
     */
    protected class AnimationTask extends AnimationTimer {
        /**
         * Wann der Timer gestartet wurde.
         */
        private long last = System.nanoTime();

        @Override
        public void handle(long now) {


            // Aktuelle Zeit
            // Wie viel Zeit ist vergangen seit dem letzten Tick
            long time = now - last;
            // Zeitdifferenz, in Sekunden
            double dtime = (time /1000000000.0);
            // Neue Zeit speichern
            last = now;

            //aktualisere Rechteck
            r.animate(dtime);
            panel.draw(dtime);
        }
    }
}
